Index: src/perl/Metacat/Metacat.pm
===================================================================
--- src/perl/Metacat/Metacat.pm	(revision 5310)
+++ src/perl/Metacat/Metacat.pm	(revision 5311)
@@ -175,6 +175,20 @@
 }
 
 #############################################################
+# subroutine to log into Metacat and get usr info xml for
+# a logged in user
+#############################################################
+sub getUserInfo {
+	my $self = shift;
+
+	my %postData = (action => 'getloggedinuserinfo');
+  
+	my $response = $self->sendData(%postData);
+
+	return $response->content;
+}
+
+#############################################################
 # subroutine to insert an XML document into Metacat
 # If success, return 1, else return 0
 #############################################################
Index: src/edu/ucsb/nceas/metacat/QuerySpecification.java
===================================================================
--- src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 5311)
@@ -164,14 +164,12 @@
         // Initialize the parser and read the queryspec
         XMLReader parser = initializeParser();
         if (parser == null) {
-            System.err.println("SAX parser not instantiated properly.");
+        	logMetacat.error("QuerySpecification() - SAX parser not instantiated properly.");
         }
         try {
             parser.parse(new InputSource(queryspec));
-        } catch (SAXException e) {
-            System.err.println("error parsing data in "
-                    + "QuerySpecification.QuerySpecification");
-            System.err.println(e.getMessage());
+        } catch (SAXException se) {
+            logMetacat.error("QuerySpecification() - SAX error parsing data: " + se.getMessage());
         }
     }
 
@@ -260,7 +258,7 @@
 	            ownerQuery = ownerQuery + "lower(user_owner) ='" + userName + "'";
 	        }
         }
-        logMetacat.info("OwnerQuery: " + ownerQuery);
+        logMetacat.info("QuerySpecification.createOwerQuery - OwnerQuery: " + ownerQuery);
         return ownerQuery;
     }
 
@@ -274,7 +272,7 @@
         String allowString = constructAllowString();
         allowQuery = "SELECT docid from xml_access WHERE( " + allowString;
         allowQuery = allowQuery + ")";
-        logMetacat.info("allow query is: " + allowQuery);
+        logMetacat.info("QuerySpecification.createAllowRuleQuery - allow query is: " + allowQuery);
         return allowQuery;
 
     }
@@ -306,7 +304,7 @@
         }//if
         // add allow rule
         allowQuery = allowQuery + ") AND perm_type = 'allow'" + " AND permission > 3";
-        logMetacat.info("allow string is: " + allowQuery);
+        logMetacat.info("QuerySpecification.constructAllowString - allow string is: " + allowQuery);
         return allowQuery;
     }
 
@@ -321,7 +319,7 @@
         String denyString = constructDenyString();
         denyQuery = "SELECT docid from xml_access WHERE( " + denyString;
         denyQuery = denyQuery + ") ";
-        logMetacat.info("denyquery is: " + denyQuery);
+        logMetacat.info("QuerySpecification.createDenyRuleQuery - denyquery is: " + denyQuery);
         return denyQuery;
 
     }
@@ -353,7 +351,7 @@
          }//if
          // add deny rules
          denyQuery = denyQuery + ") AND perm_type = 'deny'" +  " AND perm_order ='allowFirst'" +" AND permission > 3";
-         logMetacat.info("allow string is: " + denyQuery);
+         logMetacat.info("QuerySpecification.constructDenyString - deny string is: " + denyQuery);
          return denyQuery;
         
     }
@@ -371,9 +369,7 @@
         String onwer = createOwerQuery();
         String allow = createAllowRuleQuery();
         String deny = createDenyRuleQuery();
-        //logMetacat.warn("onwer " +onwer);
-        //logMetacat.warn("allow "+allow);
-        //logMetacat.warn("deny "+deny);
+
         if (onwer != null)
         {
           accessQuery = " AND (docid IN(" + onwer + ")";
@@ -385,7 +381,7 @@
         	accessQuery = " AND (docid IN (" + allow + ")"
                 + " AND docid NOT IN (" + deny + "))";
         }
-        logMetacat.warn("accessquery is: " + accessQuery);
+        logMetacat.info("QuerySpecification.getAccessQuery - access query is: " + accessQuery);
         return accessQuery;
     }
 
@@ -548,8 +544,7 @@
             parser.setErrorHandler(this);
 
         } catch (Exception e) {
-            System.err.println("Error in QuerySpcecification.initializeParser "
-                    + e.toString());
+            logMetacat.error("QuerySpecification.getAccessQuery - Error: " + e.getMessage());
         }
 
         return parser;
@@ -563,7 +558,7 @@
     public void startElement(String uri, String localName, String qName,
             Attributes atts) throws SAXException
     {
-        logMetacat.debug("start at startElement "+localName);
+        logMetacat.debug("QuerySpecification.startElement - start element " + localName);
         BasicNode currentNode = new BasicNode(localName);
         //write element name into xml buffer.
         xml.append("<");
@@ -595,7 +590,7 @@
             }
             queryStack.push(currentGroup);
         }
-        logMetacat.debug("end in startElement "+localName);
+        logMetacat.debug("QuerySpecification.startElement - ending startElement " + localName);
     }
 
     /**
@@ -606,7 +601,7 @@
     public void endElement(String uri, String localName, String qName)
             throws SAXException
     {
-    	 logMetacat.debug("start in endElement "+localName);
+    	 logMetacat.debug("QuerySpecification.endElement - endElement "+localName);
         BasicNode leaving = (BasicNode) elementStack.pop();
         if (leaving.getTagName().equals("queryterm")) {
             boolean isCaseSensitive = (new Boolean(leaving
@@ -647,9 +642,9 @@
               ownerList.add(textBuffer.toString().trim());
         }
         String normalizedXML = textBuffer.toString().trim();
-        logMetacat.debug("================before normailze "+normalizedXML);
+        logMetacat.debug("QuerySpecification.endElement - before normalize: " + normalizedXML);
         normalizedXML =  MetacatUtil.normalize(normalizedXML);
-        logMetacat.debug("================after normailze "+normalizedXML);
+        logMetacat.debug("QuerySpecification.endElement - after normalize " + normalizedXML);
         xml.append(normalizedXML);
         xml.append("</");
         xml.append(localName);
@@ -680,7 +675,7 @@
       // buffer all text nodes for same element. This is for text was splited
       // into different nodes
       String text = new String(ch, start, length);
-      logMetacat.debug("the text in characters "+text);
+      logMetacat.debug("QuerySpecification.characters - the text in characters " + text);
       textBuffer.append(text);
 
     }
@@ -715,8 +710,7 @@
 
             if (predicateEnd == -1)
             {
-                logMetacat.warn("handleReturnField(): ");
-                logMetacat.warn("    Invalid path: " + inputString);
+                logMetacat.warn("QuerySpecification.handleReturnField - Invalid path: " + inputString);
                 return;
             }
 
@@ -736,15 +730,10 @@
         }
 
         containsExtendedSQL = true;
-
-     
+   
         // no attribute value will be returned
-        logMetacat.info("QuerySpecification.handleReturnField(): " );
-        logMetacat.info("  there are no attributes in the XPATH statement" );
-        returnFieldList.add(inputString);
-       
-
-       
+        logMetacat.info("QuerySpecification.handleReturnField - there are no attributes in the XPATH statement" );
+        returnFieldList.add(inputString);       
     }
 
     /**
@@ -768,8 +757,7 @@
         } else {
         	queryFromQueryGroup = "";
         }
-        logMetacat.info("Query from query in QuerySpec.printSQL: " 
-        		+ queryFromQueryGroup);
+        logMetacat.info("QuerySpecification.printSQL - Query : " + queryFromQueryGroup);
         
         if(!queryFromQueryGroup.trim().equals("")){
             self.append(" docid IN (");
@@ -837,13 +825,13 @@
         }
 
         // if there is only one percentage search item, this query is a
-        // percentage
-        // search query
-        logMetacat.info("percentage number: "
-                + query.getPercentageSymbolCount());
-        if (query.getPercentageSymbolCount() == 1) {
-            logMetacat.info("It is a percentage search");
-            percentageSearch = true;
+        // percentage search query
+        if (query != null) {
+        	logMetacat.info("QuerySpecification.printSQL - percentage number: " + query.getPercentageSymbolCount());
+			if (query.getPercentageSymbolCount() == 1) {
+				logMetacat.info("QuerySpecification.printSQL - It is a percentage search");
+				percentageSearch = true;
+			}
         }
 
         queryString.append(self.toString());
@@ -942,11 +930,11 @@
     	    	// if there is slash in the path, path should be replace by the last part
     	    	path = path.substring(slashIndex+1);
     	    }
-    	    logMetacat.debug("In QuerySpecification.returnFieldIsAttribute method, final path is "+path);
+    	    logMetacat.debug("QuerySpecification.returnFieldIsAttribute - final path is " + path);
     	    // if first of character of path is @, the path is attribute
     	    if (path.charAt(0) == '@')
     	    {
-    	    	logMetacat.debug("it is attribute");
+    	    	logMetacat.debug("QuerySpecification.returnFieldIsAttribute - it is an attribute");
     	    	isAttribute = true;
     	    }
     	}
@@ -964,7 +952,7 @@
      *            which this user should not access
      */
     private String printExtendedSQL(String doclist) {
-        logMetacat.info("querySpecification.printExtendedSQL called\n");
+        logMetacat.debug("QuerySpecification.printExtendedSQL - in printExtendedSQL");
         StringBuffer self = new StringBuffer();
         Vector elementVector = new Vector();
         Vector attributeVector = new Vector();
@@ -996,7 +984,7 @@
 					usePathIndex = false;   
 				}
 			} catch (MetacatUtilException mue) {
-				logMetacat.warn("Could not get index paths: "  + mue.getMessage());
+				logMetacat.warn("QuerySpecification.printExtendedSQL - Could not get index paths: "  + mue.getMessage());
 			}
          
         }
@@ -1187,7 +1175,7 @@
         if (index != 0) {
             newExpression = pathExpression.substring(0, index - 1);
         }
-        logMetacat.info("The path expression without attributes: "
+        logMetacat.info("QuerySpecification.newPathExpressionWithOutAttribute - The path expression without attributes: "
                 + newExpression);
         return newExpression;
     }
@@ -1202,8 +1190,7 @@
         if (index != 1) {
             attributeName = path.substring(index + 1, size);
         }
-        logMetacat.info("The attirbute name from path: "
-                + attributeName);
+        logMetacat.info("QuerySpecification.getAttributeName - The attirbute name from path: " + attributeName);
         return attributeName;
     }
 
Index: src/edu/ucsb/nceas/metacat/SubTree.java
===================================================================
--- src/edu/ucsb/nceas/metacat/SubTree.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/SubTree.java	(revision 5311)
@@ -86,7 +86,7 @@
     {
       try
       {
-        subTreeNodeStack = getSubTreeNodeList();
+        subTreeNodeStack = getSubTreeNodeListFromDB();
       }
       catch (McdbException e)
       {
@@ -174,7 +174,7 @@
     }
 
     /* Put a subtree node into a stack, on top is the start point of subtree*/
-    private Stack getSubTreeNodeList() throws McdbException
+    private Stack getSubTreeNodeListFromDB() throws McdbException
     {
        Stack nodeRecordList = new Stack();
        // make sure it works
Index: src/edu/ucsb/nceas/metacat/PermissionController.java
===================================================================
--- src/edu/ucsb/nceas/metacat/PermissionController.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/PermissionController.java	(revision 5311)
@@ -213,7 +213,7 @@
     }//try
     catch (Exception e)
     {
-      logMetacat.warn("There is a exception in hasPermission method: "
+      logMetacat.warn("PermissionController.hasPermission - There is a exception in hasPermission method: "
                          +e.getMessage());
     }
 
@@ -373,7 +373,7 @@
         }//try
         catch( Exception e)
         {
-          logMetacat.error("error in PermissionControl.has" +
+          logMetacat.error("PermissionController.hasUnaccessableSubTree - error in PermissionControl.has" +
                                    "UnaccessableSubTree "+e.getMessage());
           throw new McdbException(e);
         }
@@ -424,7 +424,7 @@
           if (startId > subTreeStartId && endId < subTreeEndId)
           {
             needDelete = true;
-            logMetacat.info("the subtree: "+ treeId +
+            logMetacat.info("PermissionController.mergeEquivalentSubtree - the subtree: "+ treeId +
                                      " need to be get rid of from unaccessable"+
                                      " subtree list becuase it is a subtree of"+
                                      " another subtree in the list");
@@ -532,7 +532,7 @@
         // Bind the values to the query
         pStmt.setString(1, docId);
         pStmt.setString(2, principals[i]);
-        logMetacat.info("the principle stack is : " +
+        logMetacat.info("PermissionController.containDocumentOwner - the principle stack is : " +
                                   principals[i]);
 
         pStmt.execute();
@@ -541,7 +541,7 @@
         if (hasRow)
         {
           pStmt.close();
-           logMetacat.info("find the owner");
+           logMetacat.info("PermissionController.containDocumentOwner - find the owner");
           return true;
         }//if
 
@@ -885,7 +885,7 @@
         if (user != null)
         {
           usersPackage[0]= user.toLowerCase();
-          logMetacat.info("after transfer to lower case(not null): "+
+          logMetacat.info("PermissionController.createUsersPackage - after transfer to lower case(not null): "+
                                      usersPackage[0]);
         }
         else
@@ -892,7 +892,7 @@
         {
           usersPackage[0] = user;
           usersPackage[0]= user.toLowerCase();
-          logMetacat.info("after transfer to lower case(null): "+
+          logMetacat.info("PermissionController.createUsersPackage - after transfer to lower case(null): "+
                                      usersPackage[0]);
         }
         usersPackage[1]=AccessControlInterface.PUBLIC;
@@ -1036,7 +1036,7 @@
         {
             if(withRevision)
             {
-                logMetacat.info("Put subtree id " + subTreeId +
+                logMetacat.info("PermissionController.getUnAccessableInlineDataIdList - Put subtree id " + subTreeId +
                                          " and " + "inline data file name " +
                                          fileId + " into " + "un" + permission +
                                          " hash");
@@ -1045,7 +1045,7 @@
             }
             else
             {
-                logMetacat.info("Put subtree id " + subTreeId +
+                logMetacat.info("PermissionController.getUnAccessableInlineDataIdList - Put subtree id " + subTreeId +
                                          " and " + "inline data file name " +
                                          DocumentUtil.getInlineDataIdWithoutRev(fileId) +
                                          " into " + "un" + permission +
Index: src/edu/ucsb/nceas/metacat/DBSAXNode.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/DBSAXNode.java	(revision 5311)
@@ -144,16 +144,20 @@
     // write a series of nodes that are MAXDATACHARS long, and then the
     // final node contains the remainder
     while (moredata) {
-        if (leftover > DBSAXHandler.MAXDATACHARS) {
+        if (leftover > (DBSAXHandler.MAXDATACHARS)) {
         	limitedData = data.substring(offset, DBSAXHandler.MAXDATACHARS);
-            leftover -= DBSAXHandler.MAXDATACHARS;
-            offset += DBSAXHandler.MAXDATACHARS;
+            leftover -= (DBSAXHandler.MAXDATACHARS - 1);
+            offset += (DBSAXHandler.MAXDATACHARS - 1);
         } else {
-        	limitedData = data;
-            moredata = false;
+        	if (data != null) {
+        		limitedData = data.substring(offset, offset + leftover);
+        	} else {
+        		limitedData = null;
+        	}
+        	moredata = false;
         }
-        endNodeId =  writeChildNodeToDBDataLimited(nodetype, nodename,
-              limitedData, docid);
+        
+        endNodeId =  writeChildNodeToDBDataLimited(nodetype, nodename, limitedData, docid);
     }
     
     return endNodeId;
Index: src/edu/ucsb/nceas/metacat/service/XMLSchema.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/XMLSchema.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/service/XMLSchema.java	(revision 5311)
@@ -98,10 +98,10 @@
 		try { 
 			this.localFileUri = SystemUtil.getContextURL() + XMLSchemaService.SCHEMA_DIR
 					+ fileName;
-			logMetacat.debug("localFileUri: " + this.localFileUri);
+			logMetacat.debug("XMLSchema.setFileName - localFileUri: " + this.localFileUri);
 		} catch (PropertyNotFoundException pnfe) {
 			localFileUri = XMLSchemaService.SCHEMA_DIR + fileName;
-			logMetacat.warn("Could not get context url. Setting localFileUri to: "
+			logMetacat.warn("XMLSchema.setFileName - Could not get context url. Setting localFileUri to: "
 					+ localFileUri);
 		}
 		try {
@@ -108,10 +108,10 @@
 			String fileDir = SystemUtil.getContextDir() + XMLSchemaService.SCHEMA_DIR
 				+ fileName;
 			this.localFileDir = FileUtil.normalizePath(fileDir);
-			logMetacat.debug("localFileDir: " + this.localFileDir);
+			logMetacat.debug("XMLSchema.setFileName - localFileDir: " + this.localFileDir);
 		} catch (PropertyNotFoundException pnfe) {
 			localFileDir = XMLSchemaService.SCHEMA_DIR + fileName;
-			logMetacat.warn("Could not get context directory. Setting localFileDir to: "
+			logMetacat.warn("XMLSchema.setFileName - Could not get context directory. Setting localFileDir to: "
 					+ localFileDir);
 		}
 	}
@@ -177,7 +177,7 @@
 			try {
 				localFileUri = SystemUtil.getContextURL() + XMLSchemaService.SCHEMA_DIR + localFileUri;
 			} catch (PropertyNotFoundException pnfe) {
-				logMetacat.warn("Could not find context url: " + pnfe.getMessage() + 
+				logMetacat.warn("XMLSchema.setLocalFileUri - Could not find context url: " + pnfe.getMessage() + 
 						". Setting schema file uri to: " + XMLSchemaService.SCHEMA_DIR + localFileUri);
 				localFileUri = XMLSchemaService.SCHEMA_DIR + localFileUri;
 			}
Index: src/edu/ucsb/nceas/metacat/service/SessionService.java
===================================================================
--- src/edu/ucsb/nceas/metacat/service/SessionService.java	(revision 5310)
+++ src/edu/ucsb/nceas/metacat/service/SessionService.java	(revision 5311)
@@ -28,6 +28,7 @@
 
 import java.io.PrintWriter;
 import java.util.Calendar;
+import java.util.Enumeration;
 import java.util.Hashtable;
 
 import javax.servlet.http.HttpServletResponse;
@@ -49,6 +50,8 @@
 	private static Hashtable<String, SessionData> sessionHash = null;
 	
 	private static final String PUBLIC_SESSION_ID = "0";
+	
+	private static Object lockObj = new Object();
 
 	/**
 	 * private constructor since this is a singleton
@@ -113,14 +116,16 @@
 	 */
 	public static void registerSession(String sessionId, String userName,
 			String[] groupNames, String password, String name) throws ServiceException {
-		if (sessionId == null) {
-			throw new ServiceException("SessionService.registerSession - " + 
-					"Cannot register a null session id");
+		synchronized(lockObj) {
+			if (sessionId == null) {
+				throw new ServiceException("SessionService.registerSession - " + 
+						"Cannot register a null session id");
+			}
+			logMetacat.debug("SessionService.registerSession - Registering session id: " + sessionId);
+			SessionData sessionData = new SessionData(sessionId, userName, groupNames,
+					password, name);
+			sessionHash.put(sessionId, sessionData);
 		}
-		logMetacat.debug("SessionService.registerSession - Registering session id: " + sessionId);
-		SessionData sessionData = new SessionData(sessionId, userName, groupNames,
-				password, name);
-		sessionHash.put(sessionId, sessionData);
 	}
 	
 	/**
@@ -130,13 +135,15 @@
 	 *            the session data object to add to the session hash
 	 */
 	public static void registerSession(SessionData sessionData) throws ServiceException {
-		if (sessionData == null) {
-			throw new ServiceException("SessionService.registerSession - " + 
-					"Cannot register null session data");
+		synchronized(lockObj) {
+			if (sessionData == null) {
+				throw new ServiceException("SessionService.registerSession - " + 
+						"Cannot register null session data");
+			}
+			logMetacat.debug("SessionService.registerSession - Registering session " + 
+					"data with id: " + sessionData.getId());
+			sessionHash.put(sessionData.getId(), sessionData);
 		}
-		logMetacat.debug("SessionService.registerSession - Registering session " + 
-				"data with id: " + sessionData.getId());
-		sessionHash.put(sessionData.getId(), sessionData);
 	}
 	
 	/**
@@ -146,16 +153,37 @@
 	 *            the id of the session to remove.
 	 */
 	public static void unRegisterSession(String sessionId) {
-		if (sessionId == null) {
-			logMetacat.error("SessionService.unRegisterSession - trying to " + 
+		synchronized(lockObj) {
+			if (sessionId == null) {
+				logMetacat.error("SessionService.unRegisterSession - trying to " + 
 					"unregister a session with null id");
+			}
+		
+			logMetacat.info("SessionService.unRegisterSession - unRegistering session: " + sessionId);
+			sessionHash.remove(sessionId);
 		}
-		
-		logMetacat.info("SessionService.unRegisterSession - unRegistering session: " + sessionId);
-		sessionHash.remove(sessionId);
 	}
 	
 	/**
+	 * Unregister all sessions from the session hash table except the public session.
+	 * 
+	 * @param sessionId
+	 *            the id of the session to remove.
+	 */
+	public static void unRegisterAllSessions() {
+		synchronized(lockObj) {
+			Enumeration<String> keyEnum = sessionHash.keys();
+			while (keyEnum.hasMoreElements()) {
+				String sessionId = keyEnum.nextElement();
+				if (!sessionId.equals(PUBLIC_SESSION_ID)) {
+					logMetacat.info("SessionService.unRegisterAllSessions - unRegistering session: " + sessionId);
+					sessionHash.remove(sessionId);
+				}
+			}
+		}
+	}
+	
+	/**
 	 * Check if a session is registered in the session hash table. 
 	 * 
 	 * @param sessionId
@@ -246,8 +274,10 @@
 		if (sessionId == null) {
 			logMetacat.error("SessionService.touchSession - trying to touch a session with null id");
 		} else if (isSessionRegistered(sessionId)) {
-			SessionData sessionData = getRegisteredSession(sessionId);
-			sessionData.setLastAccessedTime();
+			synchronized(lockObj) {
+				SessionData sessionData = getRegisteredSession(sessionId);
+				sessionData.setLastAccessedTime();
+			}
 		}
 	}
 	
@@ -260,9 +290,7 @@
 			if(lastAccessedTime.compareTo(expireTime) < 0 ) {
 				unRegisterSession(sessionId);
 			}
-		}
-		
-		
+		}		
 	}
 
 }
